//------------------------------------------------------------------------------
{
  Sunshine's Sizer  (Ver. 1.0)
  Little tool which sizes other windows. Useful when you design a website and
  want to know how it looks like with another resolution. So you don't have to
  change the resolution, just resize your browser with this tool.

  I want to mention that this is NOT my idea. I recoded Size-O-Matic from
  www.pythoness.com.

  Hope you find it (and my source) useful...

  Coded January 2003 in Delphi (of course nonvcl :-)

  MAIL: Lighten-Sunrise@gmx.de
  WEB : www.sunshine.2kx.de
        www.kickme.to/sun2k
}
//------------------------------------------------------------------------------

program Sizer;

uses
  Windows,
  Messages,
  ShellAPI;

const
  WM_NOTIFYICON = WM_APP + 120;
  ICON_NOTIFY = 12000;

  IDM_ABOUT = 11;
  IDM_CLOSE = 12;
  IDM_SHOW = 10;

  IDM_640 = 13;
  IDM_800 = 14;
  IDM_1024 = 15;
  IDM_1152 = 16;
  IDM_1280 = 17;
  IDM_1600 = 18;



var
  TargetMode : bool = false;
  MousePos : TPoint;
  TargetWin : HWND;
  TargetRect : TRECT;
  TargetWidth, TargetHeight : Integer;
  OurWinrect : TRECT;

  MyMenu : HMENU;
  p : TPOINT;
  MyBit640, MyBit800, MyBit1024, MyBit1152, MyBit1280, MyBit1600 : HBITMAP;
  MybitAbout, MyBitExit : HBITMAP;

  BufWidth, BufHeight : Array[0..255] of char;
  intBufWidth, intBufHeight : Integer;
  Code1, Code2 : Integer;

{$R MyDlg.RES}


function AddtoTray(hwnd : HWND): Bool;
var
  pnid : NOTIFYICONDATA;
  Icon : HICON;
  lpszTip : array[0..63] of Char;
begin
  lpszTip := 'Sunshines Sizer';
  Icon := LoadImage(hInstance, MAKEINTRESOURCE(102),IMAGE_ICON, 16, 16, 0);

  pnid.cbsize := sizeof(NOTIFYICONDATA);
  pnid.wnd := hwnd;
  pnid.uID := ICON_NOTIFY;
  pnid.uFlags := NIF_ICON or NIF_MESSAGE or NIF_TIP;
  pnid.uCallbackMessage := WM_NOTIFYICON;
  pnid.hIcon := Icon;
  lstrcpyn(pnid.szTip, lpszTip, sizeof(lpszTip));
  result := Shell_NotifyIcon(NIM_ADD, @pnid);
end;

function RemoveFromTray(hwnd : HWND) : bool; stdcall;
var
  pnid : NOTIFYICONDATA;
begin
  pnid.cbSize := sizeof(NOTIFYICONDATA);
  pnid.Wnd := hwnd;
  pnid.uID := ICON_NOTIFY;
  result := Shell_NotifyIcon(NIM_DELETE, @pnid);
end;


function DlgProc(hwnd : HWND; Msg, wParam : WORD; lParam : Longint): bool; stdcall;
begin
  case msg of
  WM_CLOSE : PostQuitMessage(0);

  WM_SIZE :  begin
               if wParam = SIZE_MINIMIZED then
               begin
                 ShowWindow(hwnd, SW_HIDE);
                 AddToTray(hwnd);
               end;
             end;

  WM_NOTIFYICON : begin
                    if LParam = WM_LBUTTONDBLCLK then
                    begin
	              RemoveFromTray (hwnd);
                      ShowWindow(hwnd, SW_RESTORE);
                    end;

                    if lparam = WM_RBUTTONDOWN then
                    begin
                       MyMenu := CreatePopupmenu;
                       MyBit640 := LoadBitmap(hinstance, MAKEINTRESOURCE(120));
                       MyBit800 := LoadBitmap(hinstance, MAKEINTRESOURCE(121));
                       MyBit1024 := LoadBitmap(hinstance, MAKEINTRESOURCE(122));
                       MyBit1152 := LoadBitmap(hinstance, MAKEINTRESOURCE(123));
                       MyBit1280 := LoadBitmap(hinstance, MAKEINTRESOURCE(124));
                       MyBit1600 := LoadBitmap(hinstance, MAKEINTRESOURCE(125));
                       MyBitAbout := LoadBitmap(hinstance, MAKEINTRESOURCE(130));
                       MyBitExit := LoadBitmap(hinstance, MAKEINTRESOURCE(131));

                       AppendMenu(MyMenu,MF_STRING,IDM_SHOW,'Show...');
                       AppendMenu(MyMenu,MF_STRING,IDM_640,'640x480');
                       AppendMenu(MyMenu,MF_STRING,IDM_800,'800x600');
                       AppendMenu(MyMenu,MF_STRING,IDM_1024,'1024x768');
                       AppendMenu(MyMenu,MF_STRING,IDM_1152,'1152x864');
                       AppendMenu(MyMenu,MF_STRING,IDM_1280,'1280x1024');
                       AppendMenu(MyMenu,MF_STRING,IDM_1600,'1600x1200');

                       AppendMenu(MyMenu,MF_SEPARATOR,0,nil);
                       AppendMenu(MyMenu,MF_STRING,IDM_ABOUT,'About');
                       AppendMenu(MyMenu,MF_STRING,IDM_CLOSE,'Exit');

                       SetMenuItemBitmaps(MyMenu,1,MF_BYPOSITION,MyBit640,MyBit640);
                       SetMenuItemBitmaps(MyMenu,2,MF_BYPOSITION,MyBit800,MyBit800);
                       SetMenuItemBitmaps(MyMenu,3,MF_BYPOSITION,MyBit1024,MyBit1024);
                       SetMenuItemBitmaps(MyMenu,4,MF_BYPOSITION,MyBit1152,MyBit1152);
                       SetMenuItemBitmaps(MyMenu,5,MF_BYPOSITION,MyBit1280,MyBit1280);
                       SetMenuItemBitmaps(MyMenu,6,MF_BYPOSITION,MyBit1600,MyBit1600);
                       SetMenuItemBitmaps(MyMenu,8,MF_BYPOSITION,MyBitAbout,MyBitAbout);
                       SetMenuItemBitmaps(MyMenu,9,MF_BYPOSITION,MyBitExit,MyBitExit);

                       GetCursorPos(p);
                       SetForegroundWindow(hwnd);
                       TrackPopupMenu(MyMenu,TPM_RIGHTALIGN,p.X,p.Y,0,hwnd,nil);
                       DestroyMenu(MyMenu);
                    end;

                  end;
  WM_INITDIALOG : begin
                    SendMessage(hwnd, WM_SETICON, ICON_BIG,
                                LoadIcon(hinstance,MAKEINTRESOURCE(102)));
                  end;

  WM_COMMAND : begin
               case wParam of
               2 : begin
                     RemoveFromTray(hwnd);
                     PostquitMessage(0);
                   end;

               1 : MessageBoxA(Hwnd, pchar('             Sizer 1.0 by Sunshine' + #10#13#13#13 +
                                           'coded January 2003 in Delphi 5 (nonvcl)' + #10#13#13 +
                                           'Visit my site: www.sunshine.2kx.de' + #10#13#13 +
                                           'Mail : Lighten-Sunrise@gmx.de' + #10#13#13 +
                                           'View readme.txt for more...'), pchar('Sizer 1.0'), MB_OK);

               IDM_640 : SendMessage(hwnd,WM_COMMAND,640,0);
               IDM_800 : SendMessage(hwnd,WM_COMMAND,800,0);
               IDM_1024 : SendMessage(hwnd,WM_COMMAND,1024,0);
               IDM_1152 : SendMessage(hwnd,WM_COMMAND,1152,0);
               IDM_1280 : SendMessage(hwnd,WM_COMMAND,1280,0);
               IDM_1600 : SendMessage(hwnd,WM_COMMAND,1600,0);
               IDM_ABOUT : SendMessage(hwnd,WM_COMMAND,1,0);
               IDM_CLOSE : SendMessage(hwnd,WM_COMMAND,2,0);
               IDM_SHOW : SendMessage(Hwnd, WM_NOTIFYICON,0,WM_LBUTTONDBLCLK);

               640 : begin
                       SetCursor(LoadCursor(0, IDC_CROSS));
                       TargetMode := true;
                       SetCapture(hwnd);
                       TargetWidth := 640; TargetHeight := 480;
                     end;

               800 : begin
                       SetCursor(LoadCursor(0, IDC_CROSS));
                       TargetMode := true;
                       SetCapture(hwnd);
                       TargetWidth := 800; TargetHeight := 600;
                     end;
               1024 : begin
                       SetCursor(LoadCursor(0, IDC_CROSS));
                       TargetMode := true;
                       SetCapture(hwnd);
                       TargetWidth := 1024; TargetHeight := 768;
                     end;
               1152 : begin
                       SetCursor(LoadCursor(0, IDC_CROSS));
                       TargetMode := true;
                       SetCapture(hwnd);
                       TargetWidth := 1152; TargetHeight := 864;
                     end;
               1280 : begin
                       SetCursor(LoadCursor(0, IDC_CROSS));
                       TargetMode := true;
                       SetCapture(hwnd);
                       TargetWidth := 1280; TargetHeight := 1024;
                     end;
               1600 : begin
                       SetCursor(LoadCursor(0, IDC_CROSS));
                       TargetMode := true;
                       SetCapture(hwnd);
                       TargetWidth := 1600; TargetHeight := 1200;
                     end;

               1000 : begin
                        GetDlgItemText(hwnd,1001,BufWidth,sizeof(BufWidth));
                        GetDlgItemText(hwnd,1002,Bufheight,sizeof(BufHeight));
                        If (Bufwidth = '') or (BufHeight = '') then
                        begin
                          MessageBoxA(hwnd,pchar('You have to enter both height and width!'),
                                     pchar(':-('), MB_ICONERROR);
                          DLGPROC := false; exit;
                        end;

                        val(bufwidth,intbufwidth,Code1);
                        val(bufheight,intbufheight,Code2);
                        If (Code1 <> 0) or (Code2 <> 0) then
                        begin
                          MessageBox(hwnd, pchar('Please enter only numerals!'),
                                     pchar(':-('), MB_ICONERROR);
                          DlgProc := false;
                          exit;
                        end;
                        
                        // everything ok...
                        SetCursor(LoadCursor(0, IDC_CROSS));
                        TargetMode := true;
                        SetCapture(hwnd);
                        TargetWidth := intBufWidth; TargetHeight := intBufHeight;
                        

                      end;

               end;
               end;

  WM_RBUTTONDOWN : begin
                     if TargetMode then
                     begin
                       TargetMode := false;
                       LoadCursor(0,IDC_ARROW);
                       ReleaseCapture;
                     end;
                   end;  

  WM_LBUTTONDOWN : begin
                     if TargetMode then
                     begin
                       GetCursorPos(MousePos);
                       GetWindowRect(hwnd,OurWinrect);
                       If ( not PtInRect(OurWinRect,MousePos)) then
                       begin
                         TargetWin := WindowFromPoint(MousePos);
                         GetWindowRect(TargetWin,TargetRect);
                         MoveWindow(Targetwin, TargetRect.Left, Targetrect.top, TargetWidth, TargetHeight, TRUE);
                       end;
                       TargetMode := false;
                       SetCursor(LoadCursor(0,IDC_ARROW));
                       ReleaseCapture;
                     end;
                   end;


  end;
  DlgProc := False;
end;


begin
  DialogBoxParamA(HInstance,MAKEINTRESOURCE(101),0,@DlgProc,0);
  ExitProcess(hInstance);
end.
